/* IH undocumented changes:
       - realtime.txt not updating
*/
//--------------------------------------------------------------------------------------------------------------
// JavaScript Document
// original gadget.js modified by Ib Harmsen to read data from realtime.txt rather than cumulus.xml
// modified 2010-07 to allow reading from local file

System.Gadget.settingsUI = "settings.html";
interval = "";
conint = "";
localfile = 0;
usdate = "";
oldhour = 0;
count = 0;
maxcount = 10;


// is debugging ?
var dbg = new ActiveXObject("Scripting.FileSystemObject");
var bDebug = dbg.FileExists(System.Gadget.path+"\\debug.txt");
/* Development Use ONLY
function debugLog(str) {
    try{
        System.Debug.outputString(str);
        if (bDebug) debugLogFile.WriteLine(str);
    } catch(err) {}
}
*/
// Debuglog
function debugLog(str) 
{
    try
    {
        if (bDebug)
        {
            var oFSO = new ActiveXObject("Scripting.FileSystemObject");
            var iFlag = 2;
            if (str != "")
                iFlag = 8; 

            var debugLogFile = oFSO.OpenTextFile(System.Gadget.path+"\\debug.txt", iFlag);
            debugLogFile.WriteLine(new Date().toLocaleString() + ": " + str);
            debugLogFile.Close();
            debugLogFile = null;
        }
    } 
    catch(err) 
    {
    }
}
// End Dubug Log 

function initDisplay() 
{
   debugLog('Initialise - Cumulus Gadget v2.2IH');
   System.Gadget.onSettingsClosed = SettingsClosed;
   oBackground = document.getElementById("imgBackground");
   oBackground.src = "images/backgrounds/default.png";
   loadArray();
   if(checkSettings())
   {
      checkConnectivity();
   }
   else
   {
      messageOn('settings');
   }
}

function SettingsClosed()
{
   debugLog('SettingsClosed:');
   if(checkSettings())  { 
      clearMessage();
      checkConnectivity(); 
   }
   else {
      messageOn('settings');
      }  
}
   
function checkSettings()
{
   debugLog('checkSettings:');
   var txtfile = System.Gadget.Settings.readString("txtfile");
   localfile = 1;
   if (txtfile.substr(0,7) == "http://"  || txtfile == '') localfile = 0;
   var timeout = System.Gadget.Settings.readString("interval");
   usdate = System.Gadget.Settings.readString("usdate");
   debugLog('end checkSettings.  textfile: ' + txtfile + ', timeout: ' + timeout + ', localfile: ' + localfile + ', usdate: ' + usdate);
   return (txtfile == "" || timeout == "") ? false : true;
}

function rand() 
{
   var rand_no = Math.random();
   rand_no = rand_no * 10000000;
   rand_no = Math.ceil(rand_no);
   return(rand_no);
}

function createRequest()
{
   debugLog('createRequest:');
   var txtfile = System.Gadget.Settings.readString("txtfile") + '?uid=' + rand();
   xmlHttpObj = new XMLHttpRequest();
   xmlHttpObj.onreadystatechange = readyStateHandler;
   xmlHttpObj.open('GET', txtfile, true);
   xmlHttpObj.send(null);
}

function readyStateHandler(event)
{
   debugLog('readyStateHandler:');
   if (xmlHttpObj.readyState == 4) {
         if (xmlHttpObj.status == 200)
         { // Check realtime.txt is Ready(4) and OK(200)
            var realtime = xmlHttpObj.responseText.replace(/\r\n/g, '');
            displayData(realtime);
            var int = System.Gadget.Settings.readString("interval") * 1000;
            debugLog('int: ' + int);

         } // status 200 ok
     else
        {  // any other status
           debugLog('------------------------------->Error: ' + xmlHttpObj.readyState + ' ' + xmlHttpObj.status);
           var int = 500;

        } // END status
     interval = setInterval('checkConnectivity()', int);
   } // END readyState 4
}// END function

function displayData(realtime)
{
            debugLog('displayData:');
            var realtime = realtime.split(" ");

            var sitename = System.Gadget.Settings.readString("sitename");
            if (sitename != 1) sitename = 0;
            var site = "";
            if (sitename)
            {
              site = System.Gadget.Settings.readString("txtfile");
              var p2 = site.search("realtime.txt");
              var p1 = 7;
              if (localfile) p1 = 0;
              site = site.substr(p1,p2-p1-1) + ':';
            }

            var time = realtime[1];
            if ((oldhour) == time)
            {
               if (count < maxcount) count = count + 1;
               else  site = "<span style='color:#ff0000'>NB: not updating....</span>";  //color red
            }
            else count = 0;
            debugLog('count: ' + count + ' ,oldhour: ' + oldhour + ' ,time: ' + time + ', site: ' + site);
            oldhour = time;

            var date = realtime[0];
            var usdate = System.Gadget.Settings.readString("usdate");
            if (usdate != "")
            {
              var splt = date.substr(2,1);     //get separation char.
              var datefld = date.split(splt);
              var date = datefld[1] + usdate + datefld[0] + usdate + datefld[2];
            }
            var temp2 = System.Gadget.Settings.readString("temperature2");


            var dattim = date + ' ' + time;
            var temp = realtime[2];

            var hum  = realtime[3] + ' %';
//          var wspd = realtime[6] + ' ' + realtime[13];
            var wspd = realtime[5] + ' ' + realtime[13];  // changed to average speed
//          var bear = realtime[11];
            var bear = realtime[51];                      // changed to average direction
            var rain = realtime[9] + ' ' + realtime[16];
            var pres = realtime[10] + ' ' + realtime[15];
            var forex = realtime[48] * 1;   // make numeric
            var ptr = realtime[18] * 1;     // make numeric
            var ttr = realtime[25] * 1;     // make numeric

            if (temp2 == "")          // default: compute a feels like temperature ...
            {
              temp2 = realtime[2] * 1;   // default: outside temperature
              var tempc = realtime[24] *1;
              if (temp2 > tempc) temp2 = tempc;  // use wind chill if smaller
              else
              {
                tempc = realtime[41] * 1;
                if (temp2 < tempc) temp2 = tempc;  // use heat index if larger
              }
              temp = temp + '/' + temp2;
            }
            else if (temp2 > 0 && temp2 < 58) temp = temp + '/' + realtime[temp2];
            temp = temp + ' ' + realtime[14];      

            if(forex == -1) forex = 27; // exceptionally fine
            if(forex == -26) forex = 28; // exceptionally bad

            var night = 1 - (realtime[49] * 1); // make numeric
            oBackground.src = (night ? night_img[forex] : day_img[forex]);
            var mycolors = (night ? "<span style='color:#ffff99'>" : "<span style='color:#663333'>");

            var trendup = (night ? "<span style='color:#00ff00'>&#8593;</span>" : "<span style='color:#006400'>&#8593;</span>");
            var trenddn = (night ? "<span style='color:#ff00ff'>&#8595;</span>" : "<span style='color:#ff00ff'>&#8595;</span>");

            var ttrend = " ";
            if (ttr > 0) ttrend = trendup;
            if (ttr < 0) ttrend = trenddn;
            var ptrend = " ";
            if (ptr > 0) ptrend = trendup;
            if (ptr < 0) ptrend = trenddn;

            document.getElementById('site').innerHTML =  site;
            document.getElementById('temp').innerHTML =  ttrend + mycolors + temp + '</span>';
            document.getElementById('humidity').innerHTML = mycolors + hum + '</span>';
            document.getElementById('rainfall').innerHTML = mycolors + rain + '</span>';
            document.getElementById('wspeed').innerHTML = mycolors + wspd + '</span>';
            document.getElementById('wdir').innerHTML = mycolors + bear + '</span>';
            document.getElementById('pressure').innerHTML = ptrend + mycolors + pres + '</span>';
            document.getElementById('lasttime').innerHTML = mycolors + dattim + '</span>';
            debugLog('end displayData.');
}



function checkConnectivity()
{
   debugLog('checkConnectivity:');
   if(interval != '')
   {
      clearInterval(interval);
      interval = '';
   }
   else ;
   
   if(conint != '')
   {
      clearInterval(conint);
      conint = '';
   }
   if (localfile)
   {
      var txtfile = System.Gadget.Settings.readString("txtfile");
      debugLog('   localfile: ' + txtfile);
      var ftxt = new ActiveXObject("Scripting.FileSystemObject");
      var btxt = ftxt.FileExists(txtfile);
      if (btxt)
      {
        fread = ftxt.OpenTextFile(txtfile, 1);
        while (!fread.AtEndOfStream)
        {
           var realtime = fread.ReadAll();
           debugLog('   read it...');
        }
        fread.Close();
        debugLog('     realtime: ' + realtime.substr(0,18));
        clearMessage();
        displayData(realtime);
        var int = System.Gadget.Settings.readString("interval") * 1000;
        interval = setInterval('checkConnectivity()', int);
        debugLog('   interval set: ' + int);
      }
      else
      {
        messageOn('unavailable');
        conint = setInterval('checkConnectivity()', 500);
        debugLog('............. local realtime.txt unavailable.   Checking back in 500 milliseconds.');
      }
      btxt = null;
   }
   else
   {
     var txtfile = System.Gadget.Settings.readString("txtfile") + '?uid=' + rand();
     var xmlReq = new XMLHttpRequest();
     xmlReq.open("HEAD", txtfile, false);
     xmlReq.send(null);
     if (xmlReq.status == 200) {
        clearMessage();
        createRequest();
     }
     else
     {
        messageOn('unavailable');
        conint = setInterval('checkConnectivity()', 500);
     }
   }
   debugLog('end checkConnectivity');
}

function messageOn(mode)
{
   debugLog('messageOn: ' + mode);
   
   var message = document.getElementById('message');
   var unavailable = document.getElementById('unavailable');
   var settings = document.getElementById('settings');
   var loading = document.getElementById('loading');
   
   oBackground.src = "images/backgrounds/default.png";
   message.style.display = 'block';
   if (mode == 'settings') {
      settings.style.display = 'block';
   } else if (mode == 'unavailable') { 
      unavailable.style.display = 'block';
   } else if (mode == 'loading') { 
      loading.style.display = 'block';
   }
}

function clearMessage()
{
   debugLog('clearMessage:');
   var message = document.getElementById('message');
   var unavailable = document.getElementById('unavailable');
   var settings = document.getElementById('settings');
   var loading = document.getElementById('loading');
   
   message.style.display = 'none';
   settings.style.display = 'none';
   unavailable.style.display = 'none';
   loading.style.display = 'none';  
   debugLog('end clearMessage:');
}

function loadArray()
{
debugLog('LoadArray:');
// --- Cumulus forecast (if used) and any personal graphics

day_img   = new Array();   // Day Graphics
night_img = new Array();   //Night Graphics

// -- define arrays content
day_img[0]  = "images/backgrounds/day/blank.png"; // No Forecast (ie. not Cumulus)
day_img[1]  = "images/backgrounds/day/fine.png"; // Settled fine
day_img[2]  = "images/backgrounds/day/fine.png"; // Fine weather
day_img[3]  = "images/backgrounds/day/mostly_fine.png"; // Becoming fine
day_img[4]  = "images/backgrounds/day/mostly_fine.png"; // Fine, becoming less settled
day_img[5]  = "images/backgrounds/day/odd_showers.png"; // Fine, possible showers
day_img[6]  = "images/backgrounds/day/sun_cloud.png"; // Fairly fine, improving
day_img[7]  = "images/backgrounds/day/odd_showers.png"; // Fairly fine, possible showers early
day_img[8]  = "images/backgrounds/day/odd_showers.png"; // Fairly fine, showery later
day_img[9]  = "images/backgrounds/day/odd_showers.png"; // Showery early, improving
day_img[10]  = "images/backgrounds/day/cloud_sun.png"; // Changeable, mending
day_img[11] = "images/backgrounds/day/odd_showers.png"; // Fairly fine, showers likely
day_img[12] = "images/backgrounds/day/cloud_sun.png"; // Rather unsettled clearing later
day_img[13] = "images/backgrounds/day/cloud_sun.png"; // Unsettled, probably improving
day_img[14] = "images/backgrounds/day/odd_showers.png"; // Showery, bright intervals
day_img[15] = "images/backgrounds/day/showers.png"; // Showery, becoming less settled
day_img[16] = "images/backgrounds/day/overcast.png"; // Changeable, some precipitation
day_img[17] = "images/backgrounds/day/cloud_sun.png"; // Unsettled, short fine intervals
day_img[18] = "images/backgrounds/day/overcast.png"; // Unsettled, precipitation later
day_img[19] = "images/backgrounds/day/rain.png"; // Unsettled, some precipitation
day_img[20] = "images/backgrounds/day/overcast.png"; // Mostly very unsettled
day_img[21] = "images/backgrounds/day/rain.png"; // Occasional precipitation, worsening
day_img[22] = "images/backgrounds/day/rain.png"; // Precipitation at times, very unsettled
day_img[23] = "images/backgrounds/day/rain.png"; // Precipitation at frequent intervals
day_img[24] = "images/backgrounds/day/heavy_rain.png"; // Precipitation, very unsettled
day_img[25] = "images/backgrounds/day/heavy_rain.png"; // Stormy, may improve
day_img[26] = "images/backgrounds/day/storm.png";  // Stormy, much rain
day_img[27] = "images/backgrounds/day/fine.png"; // Exceptionally FINE
day_img[28] = "images/backgrounds/day/storm.png";  // Exceptionally BAD

night_img[0]  = "images/backgrounds/night/blank.png"; // No Forecast (ie. not Cumulus)
night_img[1]  = "images/backgrounds/night/fine.png"; // Settled fine
night_img[2]  = "images/backgrounds/night/fine.png"; // Fine weather
night_img[3]  = "images/backgrounds/night/mostly_fine.png"; // Becoming fine
night_img[4]  = "images/backgrounds/night/mostly_fine.png"; // Fine, becoming less settled
night_img[5]  = "images/backgrounds/night/odd_showers.png"; // Fine, possible showers
night_img[6]  = "images/backgrounds/night/moon_cloud.png"; // Fairly fine, improving
night_img[7]  = "images/backgrounds/night/odd_showers.png"; // Fairly fine, possible showers early
night_img[8]  = "images/backgrounds/night/odd_showers.png"; // Fairly fine, showery later
night_img[9]  = "images/backgrounds/night/odd_showers.png"; // Showery early, improving
night_img[10]  = "images/backgrounds/night/cloud_moon.png"; // Changeable, mending
night_img[11] = "images/backgrounds/night/odd_showers.png"; // Fairly fine, showers likely
night_img[12] = "images/backgrounds/night/cloud_moon.png"; // Rather unsettled clearing later
night_img[13] = "images/backgrounds/night/cloud_moon.png"; // Unsettled, probably improving
night_img[14] = "images/backgrounds/night/odd_showers.png"; // Showery, bright intervals
night_img[15] = "images/backgrounds/night/showers.png"; // Showery, becoming less settled
night_img[16] = "images/backgrounds/night/overcast.png"; // Changeable, some precipitation
night_img[17] = "images/backgrounds/night/cloud_moon.png"; // Unsettled, short fine intervals
night_img[18] = "images/backgrounds/night/overcast.png"; // Unsettled, precipitation later
night_img[19] = "images/backgrounds/night/rain.png"; // Unsettled, some precipitation
night_img[20] = "images/backgrounds/night/overcast.png"; // Mostly very unsettled
night_img[21] = "images/backgrounds/night/rain.png"; // Occasional precipitation, worsening
night_img[22] = "images/backgrounds/night/rain.png"; // Precipitation at times, very unsettled
night_img[23] = "images/backgrounds/night/rain.png"; // Precipitation at frequent intervals
night_img[24] = "images/backgrounds/night/heavy_rain.png"; // Precipitation, very unsettled
night_img[25] = "images/backgrounds/night/heavy_rain.png"; // Stormy, may improve
night_img[26] = "images/backgrounds/night/storm.png"; // Stormy, much rain
night_img[27] = "images/backgrounds/night/fine.png"; // Exceptionally FINE
night_img[28] = "images/backgrounds/night/storm.png"; // Exceptionally BAD

}
